local f = CreateFrame("frame")

f:SetScript("OnEvent", function(self, event, ...)
    self[event](self, ...)
end)

local function setRole()
	if (GetNumGroupMembers() == 0) or RocknRoleDB.disable then
		return
	end

	local _, itype = IsInInstance()
	if itype == "pvp" or itype == "arena" then
		return
	end

	local _, name = GetSpecializationInfo(GetSpecialization(), false, false, nil)
	local role = nil

	if name == "Protection" or name == "Blood" or name == "Guardian" or name == "Brewmaster" then
		role = "TANK"
	elseif name == "Holy" or name == "Restoration" or name == "Discipline" or name == "Mistweaver" then
		role = "HEALER"
	else
		role = "DAMAGER"
	end

	UnitSetRole("player", role)

end

function f:GROUP_ROSTER_UPDATE()
	f:UnregisterEvent("GROUP_ROSTER_UPDATE")
	f:RegisterEvent("CANCEL_SUMMON")
	setRole()
end

function f:CANCEL_SUMMON()
	f:UnregisterEvent("CANCEL_SUMMON")
	f:RegisterEvent("GROUP_ROSTER_UPDATE")
end

function f:PLAYER_ENTERING_WORLD()
	setRole()
end

function f:ACTIVE_TALENT_GROUP_CHANGED()
	setRole()
end

function f:ROLE_POLL_BEGIN()
	setRole()
	RolePollPopupCloseButton:Click()
end

f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("GROUP_ROSTER_UPDATE")
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
f:RegisterEvent("ROLE_POLL_BEGIN")



function f:ADDON_LOADED(addon)
    if addon ~= "RocknRole" then return end

    local defaults = {
		disable = false
	}
		
	RocknRoleDB = RocknRoleDB or {}
		
	for k,v in pairs(defaults) do
		if RocknRoleDB[k] == nil then
			RocknRoleDB[k] = v
		end
	end

	if RocknRoleDB.disable == true then
		f:UnregisterEvent("ADDON_LOADED")
		f:UnregisterEvent("GROUP_ROSTER_UPDATE")
		f:UnregisterEvent("PLAYER_ENTERING_WORLD")
		f:UnregisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
		f:UnregisterEvent("ROLE_POLL_BEGIN")
	else
		setRole()
	end


	SLASH_ROCKNROLE1, SLASH_ROCKNROLE2 = "/rnr", "/rocknrole"
	SlashCmdList.ROCKNROLE = function(msg)
		msg = msg:lower():gsub(" ", "")

		if RocknRoleDB.disable then
			RocknRoleDB.disable = false

			f:RegisterEvent("ADDON_LOADED")
			f:RegisterEvent("GROUP_ROSTER_UPDATE")
			f:RegisterEvent("PLAYER_ENTERING_WORLD")
			f:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
			f:RegisterEvent("ROLE_POLL_BEGIN")

			print("Rock 'n Role is now |cff00DD00enabled|r.")
		else 
			RocknRoleDB.disable = true

			f:UnregisterEvent("ADDON_LOADED")
			f:UnregisterEvent("GROUP_ROSTER_UPDATE")
			f:UnregisterEvent("PLAYER_ENTERING_WORLD")
			f:UnregisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
			f:UnregisterEvent("ROLE_POLL_BEGIN")

			print("Rock 'n Role is now |cffFF0000disabled|r.")

		end

	end


end